Annotation of elwix/build_3thparty.sh, revision 1.4.2.3

1.2       misho       1: #!/bin/sh
                      2: #
                      3: # ELWIX build script for cross compiling 3th party software
                      4: #
                      5: # (C) AITNET ltd - Sofia/Bulgaria <office@aitnet.org>
                      6: #    by Michael Pounov <misho@elwix.org>
                      7: #
1.4.2.3 ! misho       8: # $Id: build_3thparty.sh,v 1.4.2.2 2014/01/07 09:26:42 misho Exp $
1.2       misho       9: #
                     10: 
                     11: [ -r ./config/rc.elwix ] && . ./config/rc.elwix
1.4.2.1   misho      12: if [ -r ./config/rc.3thparty_helper ]; then
                     13:        . ./config/rc.3thparty_helper
                     14: else
                     15:        echo
                     16:        echo "ELWIX project is not configured - Missing rc.3thparty_helper script"
                     17:        echo
                     18:        exit 1
                     19: fi
                     20: 
1.2       misho      21: if [ X"${ELWIX_IS_CONFIGURED}" != X"YES" ]; then
                     22:        echo
                     23:        echo "ELWIX project is not configured !?!"
                     24:        echo
                     25:        exit 1
                     26: fi
                     27: V=${VERSION}
                     28: [ -r ${CENV} ] && . ${CENV}
                     29: unset INSTALL
                     30: unset VERSION
                     31: VERSION="$V"
                     32: 
                     33: if [ ! -d $BSDSRC ]; then
                     34:        echo
                     35:        echo "ELWIX project is not configured - missing BSD sources !?!"
                     36:        echo
                     37:        exit 1
                     38: fi
                     39: 
                     40: if [ ! -d $DEST ]; then
                     41:        echo
                     42:        echo "ELWIX project is not configured - missing Dest directory !?!"
                     43:        echo
                     44:        exit 1
                     45: fi
                     46: 
                     47: clean_3th()
                     48: {
                     49:        echo "+++ Clean ELWIX 3th party ..."
                     50: 
1.3       misho      51:        rm -rf ${PKG} ${ROMFS_USR2}
                     52: 
1.2       misho      53:        install -d ${PKG}
                     54:        install -d ${PKG}/bin
                     55:        install -d ${PKG}/etc
                     56:        install -d ${PKG}/include
                     57:        install -d ${PKG}/man
                     58:        install -d ${PKG}/lib
                     59:        install -d ${PKG}/libexec
                     60:        install -d ${PKG}/sbin
1.3       misho      61: 
                     62:        install -d ${ROMFS_USR2}
                     63:        install -d ${ROMFS_USR2}/bin
                     64:        install -d ${ROMFS_USR2}/etc
                     65:        install -d ${ROMFS_USR2}/lib
                     66:        install -d ${ROMFS_USR2}/libexec
                     67:        install -d ${ROMFS_USR2}/sbin
1.2       misho      68: }
                     69: 
                     70: compile_3th()
                     71: {
                     72:        echo "+++ Compile ELWIX 3th party ..."
                     73: 
1.4.2.2   misho      74:        BUILD_SH="./config/rc.3thparty_helper"
                     75: 
                     76:        ${BUILD_SH} expat ${CBUILD} ${PKG} ${TARGET_BUILD}
1.2       misho      77:        [ $? -ne 0 ] && exit 1
                     78:        ./build.sh libevent ${CBUILD} ${PKG} ${TARGET_BUILD}
                     79:        [ $? -ne 0 ] && exit 1
                     80:        ./build.sh libiconv ${CGBUILD} ${PKG} ${TARGET_BUILD}
                     81:        [ $? -ne 0 ] && exit 1
                     82:        ./build.sh pcre ${CBUILD} ${PKG} ${TARGET_BUILD}
                     83:        [ $? -ne 0 ] && exit 1
                     84:        ./build.sh mini_sendmail ${CBUILD} ${PKG} ${TARGET_BUILD}
                     85:        [ $? -ne 0 ] && exit 1
                     86:        ./build.sh choparp ${CBUILD} ${PKG} ${TARGET_BUILD}
                     87:        [ $? -ne 0 ] && exit 1
                     88:        ./build.sh scan_ffs ${CBUILD} ${PKG} ${TARGET_BUILD}
                     89:        [ $? -ne 0 ] && exit 1
1.4.2.2   misho      90: #      ./build.sh istgt ${CBUILD} ${PKG} ${TARGET_BUILD}
                     91: #      [ $? -ne 0 ] && exit 1
1.2       misho      92:        ./build.sh rsync ${CBUILD} ${PKG} ${TARGET_BUILD}
                     93:        [ $? -ne 0 ] && exit 1
                     94:        ./build.sh ttcp ${CBUILD} ${PKG} ${TARGET_BUILD}
                     95:        [ $? -ne 0 ] && exit 1
                     96:        ./build.sh mpd ${CBUILD} ${PKG} ${TARGET_BUILD}
                     97:        [ $? -ne 0 ] && exit 1
                     98:        ./build.sh mrouted ${CGBUILD} ${PKG} ${TARGET_BUILD}
                     99:        [ $? -ne 0 ] && exit 1
                    100:        ./build.sh igmpproxy ${CBUILD} ${PKG} ${TARGET_BUILD}
                    101:        [ $? -ne 0 ] && exit 1
                    102:        ./build.sh sudo ${CBUILD} ${PKG} ${TARGET_BUILD}
                    103:        [ $? -ne 0 ] && exit 1
                    104:        ./build.sh bmon ${CGBUILD} ${PKG} ${TARGET_BUILD}
                    105:        [ $? -ne 0 ] && exit 1
                    106:        ./build.sh mtr ${CBUILD} ${PKG} ${TARGET_BUILD}
                    107:        [ $? -ne 0 ] && exit 1
                    108:        ./build.sh ipguard ${CBUILD} ${PKG} ${TARGET_BUILD}
                    109:        [ $? -ne 0 ] && exit 1
                    110:        ./build.sh smartmontools ${CBUILD} ${PKG} ${TARGET_BUILD}
                    111:        [ $? -ne 0 ] && exit 1
                    112:        ./build.sh quagga ${CBUILD} ${PKG} ${TARGET_BUILD}
                    113:        [ $? -ne 0 ] && exit 1
                    114:        ./build.sh iftop ${CBUILD} ${PKG} ${TARGET_BUILD}
                    115:        [ $? -ne 0 ] && exit 1
                    116:        ./build.sh arping ${CBUILD} ${PKG} ${TARGET_BUILD}
                    117:        [ $? -ne 0 ] && exit 1
                    118:        ./build.sh hping2 ${CGBUILD} ${PKG} ${TARGET_BUILD}
                    119:        [ $? -ne 0 ] && exit 1
                    120:        ./build.sh trafshow ${CBUILD} ${PKG} ${TARGET_BUILD}
                    121:        [ $? -ne 0 ] && exit 1
                    122:        ./build.sh ipsec-tools ${CBUILD} ${PKG} ${TARGET_BUILD}
                    123:        [ $? -ne 0 ] && exit 1
1.4       misho     124: #      ./build.sh dhcp ${CBUILD} ${PKG} ${TARGET_BUILD}
                    125: #      [ $? -ne 0 ] && exit 1
                    126: #      ./build.sh dhcping ${CBUILD} ${PKG} ${TARGET_BUILD}
                    127: #      [ $? -ne 0 ] && exit 1
                    128:        ./build.sh dnsmasq ${CBUILD} ${PKG} ${TARGET_BUILD}
1.2       misho     129:        [ $? -ne 0 ] && exit 1
                    130:        ./build.sh miniupnpd ${CBUILD} ${PKG} ${TARGET_BUILD}
                    131:        [ $? -ne 0 ] && exit 1
                    132:        ./build.sh miniupnpc ${CGBUILD} ${PKG} ${TARGET_BUILD}
                    133:        [ $? -ne 0 ] && exit 1
                    134:        ./build.sh ntp ${CBUILD} ${PKG} ${TARGET_BUILD}
                    135:        [ $? -ne 0 ] && exit 1
1.4       misho     136:        ./build.sh spawn-fcgi ${CBUILD} ${PKG} ${TARGET_BUILD}
                    137:        [ $? -ne 0 ] && exit 1
                    138:        ./build.sh lighttpd ${CBUILD} ${PKG} ${TARGET_BUILD}
                    139:        [ $? -ne 0 ] && exit 1
1.2       misho     140:        ./build.sh libxml2 ${CBUILD} ${PKG} ${TARGET_BUILD}
                    141:        [ $? -ne 0 ] && exit 1
                    142:        ./build.sh php ${CBUILD} ${PKG} ${TARGET_BUILD}
                    143:        [ $? -ne 0 ] && exit 1
1.3       misho     144: }
                    145: 
                    146: install_3th()
                    147: {
                    148:        LIBS="${ROMFS_USR2}/lib"
                    149:        LIBEXEC="${ROMFS_USR2}/libexec"
                    150:        BIN="${ROMFS_USR2}/bin"
                    151:        SBIN="${ROMFS_USR2}/sbin"
                    152:        ETC="${ROMFS_USR2}/etc"
                    153: 
                    154:        echo "+++ Install ELWIX RomFS secondary firmware ..."
                    155: 
                    156:        StripFiles \*.so\* ${PKG}/lib
                    157:        InstallFiles \*.so\* ${PKG}/lib $LIBS
                    158:        StripFiles \* ${PKG}/libexec
                    159:        InstallFiles \* ${PKG}/libexec $LIBEXEC
                    160:        StripFiles \* ${PKG}/bin
                    161:        InstallFiles \* ${PKG}/bin $BIN
                    162:        StripFiles \* ${PKG}/sbin
                    163:        InstallFiles \* ${PKG}/sbin $SBIN
                    164: 
                    165:        InstallFiles \* ${PKG}/etc $ETC
                    166: 
                    167:        chown -R root:wheel $SBIN $BIN $LIBDATA $LIBEXEC $LIBS
                    168: }
                    169: 
                    170: build_3th()
                    171: {
                    172:        echo "+++ Build ELWIX Firmware secondary image ..."
                    173: 
                    174:        cd ${ROMFS_USR2}
                    175:        pax -w -z -v -f${REL}/${ROMFS_IMG2} .
                    176:        cd -
1.2       misho     177: 
1.3       misho     178: # Stop using uzip fs
                    179: #      makefs -ominfree=0,bsize=8192,fsize=1024,optimization=space -s${ROMFS_SIZE2} \
                    180: #              ${REL}/${ROMFS_IMG2} ${ROMFS_USR2}
                    181: 
                    182: #      MDDEV=$(mdconfig -a -t vnode -f ${REL}/${ROMFS_IMG2});
                    183: #      tunefs -L elwixFirmware2 /dev/$MDDEV;
                    184: #      mdconfig -d -u $MDDEV;
                    185: 
                    186: #      mkuzip -s 8192 -o ${REL}/${ROMFS_IMG2}.uzip ${REL}/${ROMFS_IMG2};
                    187: #      mv ${REL}/${ROMFS_IMG2}.uzip ${REL}/${ROMFS_IMG2}
1.2       misho     188: }
                    189: 
                    190: ### main()
                    191: if ! SnitVer ${PKG}/elwix.ver; then
                    192:        clean_3th
                    193:        compile_3th
1.3       misho     194: 
                    195:        install_3th
                    196:        build_3th
                    197: 
                    198:        echo "ELWIX Platform:${PLATFORM} Version:${VERSION} TargetArch:${TARGET_ARCH}" >${PKG}/elwix.ver
1.2       misho     199: else
                    200:        echo "Skipped ELWIX 3th party build ..."
                    201: fi
                    202: 
                    203: echo "+++ Complete build ELWIX 3th party"

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>